from Mixin import XMLMixin

class ActivityMixin(XMLMixin):
        def getContactName(self):
                if hasattr(self, 'contact'):
                        if hasattr(self.contact, 'nom'):
                                return self.contact.nom.PCDATA
                        elif hasattr(self, 'organisateur'):
                                return self.organisateur.PCDATA
                        elif hasattr(self, 'lieu'):
                                return self.lieu.nom.PCDATA
                elif hasattr(self, 'organisateur'):
                        return self.organisateur.PCDATA
                elif hasattr(self, 'lieu'):
                        return self.lieu.nom.PCDATA
                else:
                        return None
                
        def getOrganiserName(self):
                if hasattr(self, 'organisateur'):
                        return self.organisateur.PCDATA
                elif hasattr(self.contact, 'nom'):
                        return self.contact.nom.PCDATA
                elif hasattr(self, 'lieu'):
                        return self.lieu.nom.PCDATA
                else:
                        return None

        def makeDatecorrectDebut(self):
                if hasattr(self, 'heure'):
                        workHour = self.heure.PCDATA.encode('latin-1')
                        hIndex = workHour.find('h')
                        if hIndex < 0:
                                raise 'Ou est le h ?'
                        else:
                                hour = int(workHour[:hIndex])
                                try:
                                        minute = int(workHour[hIndex+1:])
                                except ValueError:
                                        minute = 0
##                        hourLength = len(workHour)
##                        print hourLength
                        
                        workTS = '%02d:%02d:00' % (hour, minute)
                else:
                        workTS = '00:00:00'
              
                if hasattr(self, 'date_debut'):
                        allstartDate = self.date_debut.PCDATA.encode('latin-1')
                        workDate = allstartDate[0:2]
                        workMonth = allstartDate[3:8]
                        dateDebut = self.transformMonth(workMonth, workDate)
                        timeStamp = dateDebut + ' ' + workTS
                else:
                        dateDebut = '2002-05-27'
                        timeStamp = dateDebut + ' ' + workTS
                return timeStamp
                         
        def makeDatecorrectFin(self):
                if hasattr(self, 'heure'):
                        workHour = self.heure.PCDATA.encode('latin-1')
                        hIndex = workHour.find('h')
                        if hIndex < 0:
                                raise 'Ou est le h ?'
                        else:
                                hour = int(workHour[:hIndex])
                                try:
                                        minute = int(workHour[hIndex+1:])
                                except ValueError:
                                        minute = 0
##                        hourLength = len(workHour)
##                        print hourLength
                        
                        workTS = '%02d:%02d:00' % (hour, minute)
                else:
                        workTS = '00:00:00'
              
                if hasattr(self, 'date_fin'):
                        allendDate = self.date_fin.PCDATA.encode('latin-1')
                        workDate = allendDate[0:2]
                        workMonth = allendDate[3:8]
                        dateFin = self.transformMonth(workMonth, workDate)
                        timeStamp = dateFin + ' ' + workTS
                elif hasattr(self, 'date_debut'):
                        allstartDate = self.date_debut.PCDATA.encode('latin-1')
                        workDate = allstartDate[0:2]
                        workMonth = allstartDate[3:8]
                        dateFin = self.transformMonth(workMonth, workDate)
                        timeStamp = dateFin + ' ' + workTS
                else:
                        dateFin = '2002-05-27'
                        timeStamp = dateFin + ' ' + workTS
                return timeStamp
        
        def transformMonth(self, workMonth, workDate):
                if workMonth == 'mars ':
                        allWorkDate = '2002-03-' + workDate
                elif workMonth == 'avril':
                        allWorkDate = '2002-04-' + workDate
                else:
                        allWorkDate = '2002-05-' + workDate
                return allWorkDate
